import { Alert } from "react-native";
import { is2Wflow } from "react-native-digitcamera/src/common/Constants";
import { getActivityid } from "react-native-digitcamera/src/common/Services/getActivityid";
import UploadFile from "react-native-digitcamera/src/Screens/UploadFile";
import { async } from "validate.js";
import Database from "../../../../../Components/common/DAsyncStorage";
import store from "react-native-digitcamera/src/redux/store";
import { NamedModal } from "react-native-digitcamera/src/common/GlobalModal";
import {
  callChassisPoseDetection,
  callPoseDetection,
  canCreateActivityId,
  canUpload,
  getCurrentActivity,
  updateActivityId,
} from "react-native-digitcamera/src/Screens/OfflineFlow/CommonFunc";
import { startOfflineBackgroundUpload } from "react-native-digitcamera/src/Screens/SilentUpload/SilentUploadUtils";
import { initMediaFile } from "react-native-digitcamera/src/Screens/SilentUploadV2/DatabaseHelpers";
import { UELogEvent } from "react-native-digitcamera/src/common/libEventLog/UserExperior/LibUserExperior";
import {
  errorRecord,
  firebaseAttributes,
} from "react-native-digitcamera/src/common/libEventLog/libCrashlytics/libCrashlyticsEvent";
var sensorImageDetails = [];

export const CreateActivityId = async (
  activityDetails,
  updateReduxCallback,
  addSensorDataCallback
) => {
  try {
    console.log("Activity to be created : ", activityDetails);
    var vechicleData = await Database.get("PIVechicleData");
    const AppLoginStatus = await Database.get("AppLoginStatus");
    if (
      canCreateActivityId(activityDetails?.activityId) ||
      activityDetails?.activityId == undefined ||
      activityDetails?.activityId == null
    ) {
      console.log("**** CreateActivityId called");
      //API call
      console.log("In if     ", activityDetails?.activityId);
      const { getUserDetails } = require("../../common/Who");
      await getUserDetails();
      const {
        emailId,
        name,
        phoneNo,
        panHolderName,
        panNo,
        agentNumber,
      } = require("../../common/Who");
      const USERTYPE = AppLoginStatus?.userType;
      let body;
      var registrationNumber = activityDetails?.regNumber;
      var quoteNumber = activityDetails?.policyNumber;
      var activityTypeId = activityDetails?.activityTypeId;
      var toTutorial = vechicleData?.toTutorial;
      var toWithQuote = vechicleData?.toWithQuote;
      var regNumber;
      if (USERTYPE === "Customer") {
        body = {
          activityTypeId: activityTypeId,
          customerDetailData: {
            emailId: emailId,
            name: name,
            phoneNo: phoneNo,
          },
          licensePlateNumber: registrationNumber,
          previousPolicyExpired: true,
          quoteNumber: quoteNumber,
        };
      } else if (USERTYPE === "DealerOrAgent") {
        body = {
          activityTypeId: activityTypeId,
          customerDetailData: {
            emailId: emailId,
            name: name,
            phoneNo: phoneNo,
            panHolderName: panHolderName,
            panNo: panNo,
          },
          agentId: agentNumber,
          licensePlateNumber: registrationNumber,
          previousPolicyExpired: true,
          quoteNumber: quoteNumber,
        };
      }
      console.log("CreateActivity : body : ", body);
      console.log("CreateActivity : body : ", body.activityTypeId);
      var activityData = await getActivityid({ body });
      console.log(
        "activityData?.activityID : ",
        activityData?.activityID,
        activityData.activityTypeId
      );
      await updateActivityId(activityDetails, activityData?.activityID);

      var updatedRegistrationNumber =
        activityData?.additionalActivitiesList.filter((item) => {
          if (item.key == "Registration Number") {
            return item;
          }
        });
      let userNCB = activityData?.additionalActivitiesList.filter((item) => {
        if (item.key == "User NCB") {
          return item;
        }
      });
      if (updatedRegistrationNumber.length > 0) {
        console.log(
          "CreateActivityID.js : RegNumber Available : ",
          updatedRegistrationNumber
        );
        regNumber = updatedRegistrationNumber[0]?.value;
        console.log(
          "updatedRegistrationNumber >>> >> > :",
          updatedRegistrationNumber
        );

        await updateActivityKey(
          activityData.activityID,
          "regNumber",
          updatedRegistrationNumber[0]?.value
        );
      } else {
        console.log("CreateActivityID.js : RegNumber Available : ");
        regNumber = "";
      }
      /**
       * If getActivityId failed
       * then show failure modal
       */
      if (!activityData) {
        await updateActivityKey(
          activityData.activityID,
          "serviceFailure",
          true
        );
        await Database.set("PIReUploadFailed", "true");
        return;
      }

      if (activityData.flag === "Manual Inspection") {
        store.dispatch({
          type: "GLOBAL_MODAL_SHOW",
          payload: NamedModal.MANUAL_INSPECTION,
        });
        return;
      }

      console.log(
        "is2Wflow(activityData.activityTypeId",
        is2Wflow(activityData.activityTypeId),
        activityDetails,
        activityData?.activityID,
        activityData.activityTypeId
      );

      // only update current activity data in PIVechicleData
      if (is2Wflow(activityData.activityTypeId)) {
        try {
          console.log(
            "CreateActivityID.js : Update PIVechicleData started: ",
            regNumber
          );
          await Database.update("PIVechicleData", {
            activityId: activityData?.activityID,
            activityTypeId: activityData?.activityTypeId,
            licensePlateNumber: regNumber,
            toWithQuote: toWithQuote,
            toTutorial: toTutorial,
            quoteNumber: quoteNumber,
            ncb:
              userNCB === undefined || userNCB.length == 0
                ? 0
                : Number(userNCB[0].value),
            vechicleType: "",
          });
          console.log(
            "CreateActivityID.js : Update PIVechicleData End: ",
            regNumber
          );
          const PIVechicleData = await Database.get("PIVechicleData");
          console.log(
            "PIVechicleData : in CreateActivity.js : after creating new Activity ",
            PIVechicleData
          );
          console.log("888888888  >>>>");
          await checkPoseDetection();
        } catch (error) {
          console.log(
            "Error: createActivityID  is2Wflow(activityData.activityTypeId) ",
            error
          );
        }
      }
      updateReduxCallback();
    }
  } catch (error) {
    console.log("Error in CreateActivityId.js ", error);
  }
};

// this function adds "value" agains a "key"  to a Activity in PIMediaStatus DB

// I'm using this to update if any of the service fails
//  /preinpsection & /instruction if failed
// then serviceFailure = true
const updateActivityKey = async (activityId, key, value) => {
  try {
    const pMediaStatus = await Database.get("PIMediaStatus");
    console.log(
      "updateActivityKey : activityId : key : value :",
      activityId,
      key,
      value
    );
    const nPIMediaStatus = pMediaStatus.map((item) => {
      if (item.activityId === activityId) {
        const newObj = item;
        newObj[key] = value;
        return newObj;
      } else {
        return item;
      }
    });
    Database.set("PIMediaStatus", nPIMediaStatus);
  } catch (error) {
    console.log("Error : CreateActivity : updateActivityKey :", error);
  }
};

var invalidData;
const checkPoseDetection = async () => {
  try {
    var activity = await getCurrentActivity();
    UELogEvent("Check Pose Detection started in InvalidImages");
    invalidData = activity.mediaUpload;
    var index = 0;
    // var fillteredInvalidData = invalidData.filter((item) => {
    //   return !canUpload(item.imageName);
    // });
    // console.log("fillteredInvalidData :", fillteredInvalidData);

    nextImage(index);
  } catch (error) {
    UELogEvent("Check Pose Detection Stopped in Catch", {
      error: JSON.stringify(error),
    });
    firebaseAttributes(error);
    errorRecord(error);
    console.log("in checkPoseDetection() ", error);
  }
};
const nextImage = async (index) => {
  try {
    console.log(
      "nextImage : invalidData :",
      invalidData.length,
      invalidData[index],
      invalidData
    );
    await getImageForPoseDetection(invalidData[index], () => {
      console.log(
        "CreateImage : Gone For Pose Detection :",
        index,
        invalidData
      );
      console.log("Index  >> >> >", index);
      index = index + 1;
      console.log("Index  >> >>  kk : ", index);
      if (index < invalidData.length) {
        nextImage(index);
      }
    });
  } catch (error) {
    console.log("Error : nextImage : ", error);
  }
};
const getImageForPoseDetection = async (item, updateIndexCallback) => {
  try {
    console.log(
      "createActivityId : getImageForPoseDetection :  Item for Pose dettection ",
      item
    );
    if (
      item?.imageName == "SF" ||
      item?.imageName == "VDO" ||
      item?.imageName == "SF" ||
      item?.imageName == "CNG" ||
      item?.imageName == "IWS" ||
      item?.imageName?.includes("RCB") ||
      item?.imageName == "PUC"
    ) {
      console.log(
        "item?.imageUri item?.imageUri : will upload",
        item?.uri,
        item?.imageName
      );
      // var ext = item?.imageName == "VDO" ? ".mp4" : ",jpg";
      // await initMediaFile(
      //   item?.uri,
      //   item?.imageName,
      //   ext,
      //   "poseSuccess",
      //   () => {
      //     updateIndexCallback();
      //   }
      // );
      updateIndexCallback();
    } else if (item?.imageName === "CHP") {
      try {
        console.log("item : CHP POSE :", item);
        await callChassisPoseDetection(
          item?.uri,
          item?.imageName,
          async () => {
            await chassiesPoseDetectionSucess(
              item?.uri,
              item?.imageName,
              () => {
                updateIndexCallback();
              }
            );
          },
          async () => {
            await chassiesPDetectionFailed(item?.uri, item?.imageName, () => {
              updateIndexCallback();
            });
          }
        );
      } catch (error) {
        await chassiesPDetectionFailed(item?.uri, item?.imageName, () => {
          updateIndexCallback();
        });
        console.log("Error : callChassisPoseDetection call : ", error);
      }
    } else {
      try {
        console.log("item? : POSE :", item);
        await callPoseDetection(
          item?.uri,
          item?.imageName,
          async () => {
            await poseDetectionSucess(item?.uri, item?.imageName, () => {
              updateIndexCallback();
            });
          },
          async () => {
            await poseDetectionFailed(item?.uri, item?.imageName, () => {
              updateIndexCallback();
            });
          }
        );
      } catch (error) {
        await poseDetectionFailed(item?.uri, item?.imageName, () => {
          updateIndexCallback();
        });
        console.log("Error : callPoseDetection call : ", error);
      }
    }
  } catch (error) {
    console.log("CreateActivityId : getImageForPoseDetection : ", error);
  }
};

const chassiesPoseDetectionSucess = async (
  uri,
  imageName,
  updateIndexCallback
) => {
  try {
    console.log("createActivity : chassiesPoseDetectionSucess ", imageName);
    console.log("Uploading chassiesPoseDetectionSucess ", imageName);
    // var ext = imageName == "VDO" ? ".mp4" : ",jpg";
    // await initMediaFile(uri, imageName, ext, "poseSuccess", () => {
    //   updateIndexCallback();
    // });
    updateIndexCallback();
  } catch (error) {
    console.log("Error : chassiesPoseDetectionSucess : ", error);
  }
};

const chassiesPDetectionFailed = async (
  uri,
  imageName,
  updateIndexCallback
) => {
  try {
    console.log("createActivity : chassiesPDetectionFailed ", imageName);
    var ext = imageName == "VDO" ? ".mp4" : ",jpg";
    await initMediaFile(uri, imageName, ext, "poseFailed", () => {
      updateIndexCallback();
    });
  } catch (error) {
    console.log("Error : chassiesPDetectionFailed : ", error);
  }
};

const poseDetectionSucess = async (uri, imageName, updateIndexCallback) => {
  try {
    console.log("createActivity : poseDetectionSucess ", imageName);
    console.log("Uploading poseDetectionSucess ", imageName);
    // var ext = imageName == "VDO" ? ".mp4" : ",jpg";
    // await initMediaFile(uri, imageName, ext, "poseSuccess", () => {
    //   updateIndexCallback();
    // });
    updateIndexCallback();
  } catch (error) {
    console.log("Error : poseDetectionSucess : ", error);
  }
};

const poseDetectionFailed = async (uri, imageName, updateIndexCallback) => {
  try {
    console.log("createActivity : poseDetectionFailed ", imageName);
    var ext = imageName == "VDO" ? ".mp4" : ",jpg";
    await initMediaFile(uri, imageName, ext, "poseFailed", () => {
      updateIndexCallback();
    });
  } catch (error) {
    console.log("Error : poseDetectionFailed : ", error);
  }
};
